<template>
  <div class="ti-form">
    <input id="queue" name="queue" v-model="mail.queue" class="input" type="hidden" value="ti">
    <p class="content" v-if="isAuthenticated">
      <strong>Chamado aberto por:</strong><br />
			{{ user.name }} ({{ user.username }}) - {{ user.sector }}<br />
			{{ user.email }}
      <b-input name="name" type="hidden" :value="user.name"></b-input>
      <b-input name="login" type="hidden" :value="user.username"></b-input>
      <b-input name="email" type="hidden" :value="user.email"></b-input>
      <b-input name="sector" type="hidden" :value="user.sector"></b-input>
		</p>
		<div v-else>
			<b-field label="Nome">
				<b-input id="name" name="name" v-model="mail.name" value=""></b-input>
			</b-field>

			<b-field label="Siape ou Matrícula">
				<b-input id="login" name="login" v-model="mail.login" value=""></b-input>
			</b-field>

			<b-field label="Setor" message="Caso seja aluno, deixe em branco">
				<b-input id="sector" name="sector" v-model="mail.sector" value=""></b-input>
			</b-field>

			<b-field label="E-mail" message="Dê preferência ao e-mail institucional">
				<b-input id="email" name="email" v-model="mail.email" value="" type="email"></b-input>
			</b-field>
    </div>
    <input id="emailto" name="emailto" class="input" type="hidden" value="suporte.acopiara@ifce.edu.br">
    <div class="field">
      <div class="control is-expanded">
        <label class="label" for="subject">Assunto</label>
        <span class="select is-fullwidth">
        <select id="subject" name="subject" v-model="mail.subject">
            <option selected disabled>Selecione uma opção</option>
            <option value="Solicitar remoção/inclusão de software">Solicitar remoção/inclusão de software</option>
            <option value="Solicitar remoção/inclusão de periférico (teclado, mouse..)">Solicitar remoção/inclusão de periférico (teclado, mouse..)</option>
            <option value="Solicitar novo tonner de impressora">Solicitar novo tonner de impressora</option>
            <option value="Solicitar novo ponto de rede">Solicitar novo ponto de rede</option>
            <option value="Informar mau funcionamento em equipamento (pc, impressora..)">Informar problema em equipamento (pc, impressora..)</option>
            <option value="Informar problema com e-mail Institucional">Informar problema com e-mail Institucional</option>
            <option value="Outros">Outros</option>
        </select>
        </span>
      </div>
    </div>

    <b-field label="Tombo do equipamento" message="Caso não tenha, deixar em branco">
      <b-input id="number" name="equipament_number" v-model="mail.equipament_number" value=""></b-input>
    </b-field>

    <div class="field">
      <label class="label" for="content">Descreva o problema/requisição aqui</label>
      <div class="control">
        <textarea id="content" name="content" v-model="mail.content" class="textarea" placeholder=""></textarea>
      </div>
    </div>
    <the-form-buttons v-on:save="save" v-on:cancel="cancel"></the-form-buttons>

    <b-loading :is-full-page="true" :active.sync="isLoading" :can-cancel="false"></b-loading>
  </div>
</template>

<script>
import TheFormButtons from '@/components/TheFormButtons'

export default {
  name: 'TIForm',
  props: {
    ticket: String,
  },
  data: function ()  {
    return {
      mail: {}
    }
  },
  created () {},
  components: {
    'the-form-buttons': TheFormButtons
  },
  methods: {
    save () {
      var payload = {}
      if (this.isAuthenticated) {
        payload = {
          name: this.user.name,
          login: this.user.username,
          sector: this.user.sector,
          email: this.user.email
        }
      } else {
        payload = {
          name: this.mail.name,
          login: this.mail.login,
          sector: this.mail.sector,
          email: this.mail.email
        }
      }
      payload['queue'] = 'ti'
      payload['emailto'] = 'suporte.acopiara@ifce.edu.br'
      payload['subject'] = this.mail.subject
      payload['number'] = this.mail.equipament_number
      payload['content'] = this.mail.content

      this.$store.dispatch('sendMail', payload)
    },
    cancel () {
      this.$router.go(-1)
    },
  },
  computed: {
    isAuthenticated () {
      return this.$store.getters.isAuthenticated
    },
		user () {
			return this.$store.getters.user
		},
    isLoading () {
      return this.$store.state.tickets.loading
    }
  }
}
</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
</style>
